/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.bpmn2bpel.generators;

import javax.wsdl.Definition;
import javax.xml.bind.JAXBException;
import javax.xml.namespace.QName;
import org.ow2.orchestra.bpmn2bpel.BpmnMap;
import org.ow2.orchestra.bpmn2bpel.components.SequenceComponent;
import org.ow2.orchestra.jaxb.bpel.Sequence;
import org.ow2.orchestra.jaxb.bpel.TActivity;
import org.ow2.orchestra.jaxb.bpmn.TFlowNode;
import org.xml.sax.SAXException;

import java.io.IOException;
import java.util.Map;


/**
 * @author Guillaume Porcher
 */
class SequenceGenerator {
  private final BpelGenerator bpelGenerator;

  SequenceGenerator() {
    this.bpelGenerator = new BpelGenerator();
  }

  /**
   * @param bpelGenerator
   */
  SequenceGenerator(final BpelGenerator bpelGenerator) {
    this.bpelGenerator = bpelGenerator;
  }

  /**
   * @param bpmnMap
   * @param sequenceComponent
   * @param processQName
   * @return
   */
  TActivity createSequenceActivity(
          final BpmnMap bpmnMap,
          final SequenceComponent sequenceComponent,
          final QName processQName,
          final Map<String, Definition> partnerWsdls) throws JAXBException, IOException, SAXException {
    // create bpel sequence
    final Sequence sequence = new Sequence();

    // fill the sequence
    for (final TFlowNode node : sequenceComponent.getSequenceNodes()) {
      final TActivity activity = this.bpelGenerator.createBpelActivity(node, bpmnMap, processQName, partnerWsdls);
      sequence.getAssignsAndCompensatesAndCompensateScopes().add(activity);
    }
    return sequence;
  }

}
